////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     ////     //        ///     //////////////////////////////////////////                 CTG-Hologram.mq4 ////
////////  ////////  //////  ////\////////////////////////////////////////                CompanyName "CTG" /////////
   ////     /////  //////       ////////////////////////////////////////     http://ChaosTradingGroup.com ////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 //// INDICATOR:  Hologram (need for work: CTG-Pattern_finder-MD)  ////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#property copyright  "Copyright  2007, ChaosTradingGroup.com"
#property link       "http://ChaosTradingGroup.com"

#property indicator_separate_window
#property indicator_buffers 2

extern string     DATA           = "close"; // volume, body, close, middle, high, low 
extern datetime   StartDate      = 0;
extern datetime   EndDate        = 0;
extern int        UCmin          = 0;       // unit consciousness in minutes (min- 16, max- history/2)
extern int        Octave         = 1;       // number octave
extern bool       UnderOctave    = false;
extern bool       Grafic         = false;
extern bool       Modify         = false;
//==work 
bool       Smoothing      = false;  // smoothing pattern at an average price bar
bool       Percentage     = false;  // calculation of percentage pattern
int        iterations     = 2;      // the minimum number of iterations

double            bh[],bf[],bp[];   // buffers: bh - history, bf - future, bp - pattern 

static int     e,i,x,p,n,Start,End,prevtime;

int            clr0,clr1,st,ESbar,EC,ECuo,notes,octave;
string         txt0,txt1,txtdata,datapat,txtuo;
bool           flg=false;

//////////////////////////////////////////////////////////////////////
// Init //////////////////////////////////////////////////////////////
int init()
  {
  OptionsControl();st=2;
    
  if(Grafic==true)
   {
   txtdata="GRAFIC";st=0;
   txt0="G-CLOSE";txt1="";clr0=Black;clr1=CLR_NONE;
   }
   else if(DATA=="volume" || DATA=="Volume" || DATA=="VOLUME")
         {
         datapat="volume";txtdata="UC="+EC+",VOLUME";
         txt0="VOLUME";txt1="F-VOLUME";clr0=Green;clr1=Green;
         }
         else if(DATA=="body" || DATA=="Body" || DATA=="BODY")
               {
               datapat="body";txtdata="UC="+EC+",BODY";
               txt0="BODY";txt1="F-BODY";clr0=Coral;clr1=Coral;
               }
               else if(DATA=="close" || DATA=="Close" || DATA=="CLOSE")
                     {
                     datapat="close";txtdata="UC="+EC+",CLOSE";
                     txt0="CLOSE";txt1="F-CLOSE";clr0=Magenta;clr1=Magenta;
                     }
                     else if(DATA=="high" || DATA=="High" || DATA=="HIGH")
                           {
                           datapat="high";txtdata="UC="+EC+",HIGH";
                           txt0="HIGH";txt1="F-HIGH";clr0=Blue;clr1=Blue;
                           }
                           else if(DATA=="low" || DATA=="Low" || DATA=="LOW")
                                 {
                                 datapat="low";txtdata="UC="+EC+",LOW";
                                 txt0="LOW";txt1="F-LOW";clr0=Red;clr1=Red;
                                 }
                                 else if(DATA=="middle" || DATA=="Middle" || DATA=="MIDDLE")
                                       {
                                       datapat="middle";txtdata="UC="+EC+",MIDDLE";
                                       txt0="MIDDLE";txt1="F-MIDDLE";clr0=MediumVioletRed;clr1=MediumVioletRed;
                                       }
                                       else {
                                             datapat="close";txtdata="UC="+EC+",CLOSE";
                                             txt0="CLOSE";txt1="F-CLOSE";clr0=Magenta;clr1=Magenta;
                                            }
   IndicatorBuffers(3);
   
   SetIndexStyle(0,DRAW_LINE,st,1,clr0);
   SetIndexEmptyValue(0,0.0);
   SetIndexDrawBegin(0,0.0);
   SetIndexStyle(1,DRAW_LINE,0,1,clr1);
   SetIndexEmptyValue(1,0.0);
   SetIndexDrawBegin(1,0.0);
   SetIndexShift(1,ESbar);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexEmptyValue(2,0.0);
   SetIndexDrawBegin(2,0.0);
   
   IndicatorDigits(Digits);
   
   SetIndexBuffer(0,bh);
   SetIndexBuffer(1,bf);
   SetIndexBuffer(2,bp);
    
   IndicatorShortName("Hologram("+txtdata+"):");
   SetIndexLabel(0,txt0);
   SetIndexLabel(1,txt1);
   
   return(0);
  }
//////////////////////////////////////////////////////////////////////
// Deinit ////////////////////////////////////////////////////////////
int deinit(){Comment("");return(0);}
//////////////////////////////////////////////////////////////////////
// Start /////////////////////////////////////////////////////////////
int start()
  {
  if(Time[0]>prevtime)
   {
   prevtime=Time[0];
   
   OptionsControl();
   //zero buf.
   for(i=End;i<=(Bars-1);i++){bh[i]=0;bf[i]=0;}
   //
   if(Grafic==true){GraficClose();}
      else  {
            notes=0;
            if(UnderOctave==true)
               {
               x=1;
               while(x<8)
                  {
                  octave=Octave;
                  ECuo=EC/KofNotes(x);
                  CalcHolo(ECuo);
                  x++;
                  }
               }
               else  {octave=Octave;CalcHolo(EC);}
            //calc iteration
            for(i=Start;i>=End;i--){bh[i]=bh[i]/(notes);bf[i]=bf[i]/(notes);}
            //info
            if(UnderOctave==false){txtuo="UnderOctave = false";}
               else {txtuo="UnderOctave = true";}
            Comment("Iterations = "+(Start-End)/ESbar+"\n"+"U = "+EC+"\n"+"Notes = "+notes+"\n"+txtuo);
            }
   }            
   return(0);
  }
//////////////////////////////////////////////////////////////////////
// Functions /////////////////////////////////////////////////////////
void CalcHolo(int CH_EC)
   {
   int CH_ECoct,CH_ECpat;
   
   if(octave==0){octave=1;}
   p=1;CH_ECoct=CH_EC;
   while(p<8)
      {
      CH_ECpat=CH_ECoct/KofNotes(p);
      Paint(CH_ECpat);
      notes++;
      if (p==7) {octave--;CH_ECoct=CH_ECoct/KofNotes(p+1);p=0;}
      if (octave<=0) break;
      p++;
      }
   }
//====================================================================
double KofNotes(int KN_switch)
   {
   double retKN;
   
   switch(KN_switch)
      {
      case 2:  retKN=1.125;         break;
      case 3:  retKN=1.25;          break;
      case 4:  retKN=1.333333333;   break;
      case 5:  retKN=1.5;           break;
      case 6:  retKN=1.666666666;   break;
      case 7:  retKN=1.875;         break;
      case 8:  retKN=2;             break;
      default: retKN=1;             break;
      }
      
   return(retKN);
   }
//====================================================================
void Paint(int P_EC)
   {
   int            P_ECbar=P_EC/Period();
   double         P_di,P_half;
   static double  P_smoothing;
   
   //calc patern
   P_di=iCustom(NULL,0,"CTG-Pattern_finder-MD",datapat,Time[Start],Time[End],P_EC,Smoothing,Percentage,0,End+1);
   if(P_di>0){n=1;}
      else  {
            P_di=iCustom(NULL,0,"CTG-Pattern_finder-MD",datapat,Time[Start],Time[End],P_EC,Smoothing,Percentage,1,End+1);
            if(P_di>0){n=2;}
               else  {n=0;}
            }
   for(i=End,e=0;e<=P_ECbar;i++,e++)
      {
      if(n==1){bp[e]=iCustom(NULL,0,"CTG-Pattern_finder-MD",datapat,Time[Start],Time[End],P_EC,Smoothing,Percentage,0,i);}
      if(n==2){bp[e]=iCustom(NULL,0,"CTG-Pattern_finder-MD",datapat,Time[Start],Time[End],P_EC,Smoothing,Percentage,1,i);}
      if(n==0){Print("no data array,EC="+P_EC); break;}
      if(e==P_ECbar){P_half=(bp[e-1]-bp[0])/(P_ECbar-1);}
      }
   //smoothing1
   if(Smoothing==false)
      {
      P_smoothing=0;
      for(e=P_ECbar-1;e>=0;e--)
         {
         bp[e]=bp[e]+P_smoothing;
         P_smoothing+=P_half;
         }
      }
   //paint history
   for(i=End,e=0;i<Start;i++,e++)
      {
      if( e >= P_ECbar ){e=0;}
      bh[i]+=bp[e];
      }
   //paint future
   for(i=End+ESbar,e=0;i>=End;i--,e--)
      {
      bf[i]+=bp[e];
      if( e <= 0 ){e=P_ECbar;}
      }
   //zero buffer patern  
   for(e=0;e<=P_ECbar;e++){bp[e]=0;}
   }
//====================================================================
void OptionsControl()
   {
   if(StartDate!=0){Start=iBarShift(NULL,0,StartDate);}
      else  {Start=Bars-1;}
   if(EndDate!=0){End=iBarShift(NULL,0,EndDate);}
      else  {End=Bars-1;}
   if(Start==End){Start=Bars-1;End=0;}
      else  {
            e=End;
            if(End>Start){End=Start;Start=e;}
               else  if(Start>End){End=End;Start=Start;}
                        else  {Start=Bars-1;End=0;}
            }
   if( (UCmin<=Period()) || ( ((Bars-1)*Period())<(UCmin*iterations) ) ){EC=DefaultEC(Period());}
      else  {EC=UCmin;} 
   if( (EC*iterations/Period()) > (Start-End) ){EC=((Start-End)/iterations)*Period();}
   ESbar=EC/Period();
   }
//====================================================================
int DefaultEC(int DEC_period)
   {
   int retDEC,DEC_UC,DEC_iter;
   
   if(Modify==true)
      {
      for (i=1;i<=28;i++)
         {
         switch(i)
            {
            case 1:  DEC_UC=11220480; break;
            case 2:  DEC_UC=8415360;  break;
            case 3:  DEC_UC=5610240;  break;
            case 4:  DEC_UC=4207680;  break;
            case 5:  DEC_UC=2805120;  break;
            case 6:  DEC_UC=2103840;  break;
            case 7:  DEC_UC=1402560;  break;
            case 8:  DEC_UC=1051920;  break;
            case 9:  DEC_UC=701280;   break;
            case 10: DEC_UC=525960;   break;
            case 11: DEC_UC=350640;   break;
            case 12: DEC_UC=262980;   break;
            case 13: DEC_UC=175320;   break;
            case 14: DEC_UC=131490;   break;
            case 15: DEC_UC=87660;    break;
            case 16: DEC_UC=65745;    break;
            case 17: DEC_UC=43830;    break;
            case 18: DEC_UC=32872;    break;
            case 19: DEC_UC=21915;    break;
            case 20: DEC_UC=16436;    break;
            case 21: DEC_UC=10957;    break;
            case 22: DEC_UC=8218;     break;
            case 23: DEC_UC=5479;     break;
            case 24: DEC_UC=4109;     break;
            case 25: DEC_UC=2739;     break;
            case 26: DEC_UC=2054;     break;
            case 27: DEC_UC=1370;     break;
            default: flg=true;        break;
            }
         DEC_iter=(Start-End)/(DEC_UC/DEC_period); 
         if(DEC_iter>5 || flg==true){break;}
         }
      retDEC=DEC_UC;
      }
      
   if(Modify==false || flg==true)
      {
      if(DEC_period>=10080 && DEC_period<43200){retDEC=43200*12;}
         else  if(DEC_period>=43200){retDEC=43200*12*4;}
                  else  {retDEC=DEC_period*720;}
      }
               
   return(retDEC);
   }
//====================================================================
void GraficClose(){ for(i=0;i<=(Bars-1);i++){bh[i]=Close[i];} }
//====================================================================